package ksync

import (
	"fmt"
	"github.com/fox/fox/log"
	"github.com/wanghuiyt/ding"
	"testing"
	"time"
)

func TestEtcd(t *testing.T) {
	log.Open("test.log", log.DebugL)
	WrapSafe(func() { fmt.Println("hello world") }, nil)
}

func TestSendDingTalkMessage(t *testing.T) {
	d := ding.Webhook{
		AccessToken: "9802639f5dea7dd4aaff98a8f264b98c224f90ceeed3c26b438534e3a79222b1",    // 上面获取的 access_token
		Secret:      "SECffd7d2afe9d0590fd04e36a0efa44d73553fb8f702eb1690e579996aec6c1386", // 上面获取的加签的值
	}
	_ = d.SendMessageText("这是普通的群消息", "13145922265", "17353003985")
}

func TestRecover(t *testing.T) {
	log.Open("test.log", log.DebugL)
	cb := func() {
		i := new(int)
		*i = 1
		i = nil
		*i = 2
	}
	GoSafe(cb, cb)
	time.Sleep(time.Minute)
}
